> ## Documentation Index
> Fetch the complete documentation index at: https://hoopdev-feat-new-runbook-parameters.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Runbook Rule

> Create a new Runbook Rule



## OpenAPI

````yaml https://use.hoop.dev/api/openapiv3.json post /runbooks/rules
openapi: 3.0.3
info:
  contact:
    email: help@hoop.dev
    name: Help
    url: https://help.hoop.dev
  description: >-
    Hoop.dev is an access gateway for databases and servers with an API for
    packet manipulation
  license:
    name: MIT
    url: https://opensource.org/license/mit
  termsOfService: https://hoop.dev/docs/legal/tos
  title: Hoop Api
  version: 1.54.3
servers:
  - url: https://use.hoop.dev/api
security: []
tags:
  - description: >
      Hoop implements Oauth2 and OIDC protocol to authenticate users in the
      system. To obtain a valid access token users need to authenticate in their
      own identity provider which is generated as a JSON response to the
      endpoint `http(s)://use.hoop.dev/api/login`. The identity provider them
      redirects the user to the callback endpoint containing the access token.


      The recommended approach of obtaining an access token is by visiting the
      Webapp main's page or using the **Hoop command line**. Example:


      ```sh

      hoop config create --api-url https://use.hoop.dev

      # save the token after authenticating at $HOME/.hoop/config.toml

      hoop login

      # show token information

      hoop config view --raw

      ```


      With an access token you could use any HTTP client to interact with the
      documented endpoints.

      The token must be sent through the `Authorization` header.


      Example:


      ```sh

      # obtain the current configuration of the server

      curl https://use.hoop.dev/api/serverinfo -H "Authorization: Bearer
      $ACCESS_TOKEN"

      ```
    name: Authentication
  - description: >
      Users are active and assigned to the default organization when they
      signup. A user could be set to an inactive state preventing it from
      accessing the platform, however it’s recommended to manage the state of
      users in the identity provider.


      - The `sub` claim is used as the main identifier of the user in the
      platform.

      - The profile of the user is derived from the id_token claims `email` and
      `name`.


      When a user authenticates for the first time, it performs an automatic
      signup that persist the profile claims along with it’s unique identifier.

      ​

      ### Groups


      Groups allows defining who may access or interact with certain resources.


      - For connection resources it’s possible to define which groups has access
      to a specific connection, this is enforced when the Access Control feature
      is enabled.

      - For review resources, it’s possible to define which groups are allowed
      to approve an execution, this is enforced when the Review feature is
      enabled.


      > This resource could be managed manually via Webapp or propagated by the
      identity provider via ID Token. In this mode, groups are sync when a user
      performs a login.


      ### Roles


      - The `admin` group is a special role that grants full access to all
      resources


      This role should be granted to users that are responsible for managing the
      Gateway. All other users are regular, meaning that they can access their
      own resources and interact with connections.
    name: User Management
  - description: Routes used to manage and obtain information about the runtime server.
    name: Server Management
  - description: Features available in the gateway. See also **Plugin** resources.
    name: Features
  - description: >-
      Proxy manager endpoints controls how clients connect via gRPC in the
      gateway. These endpoints are meant to be used when a client is initialized
      via `hoop proxy-manager`.
    name: Proxy Manager
  - name: Connections
  - name: Agents
  - name: Runbooks
  - name: Guard Rails
  - name: Reviews
  - name: Sessions
  - name: Organization Management
  - name: Reports
  - description: >
      Security audit log API. Only users in the **admin** group can access these
      endpoints.


      Audit log entries record security-relevant events (who performed an
      action, when, on which resource, and whether it succeeded). Use the list
      endpoint with filters to query by actor, resource type, action, outcome,
      or date range. Results are paginated and ordered by `created_at`
      descending.
    name: Audit Logs
paths:
  /runbooks/rules:
    post:
      tags:
        - Runbooks
      summary: Create Runbook Rule
      description: Create a new Runbook Rule
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/openapi.RunbookRuleRequest'
        description: Runbook Rule
        required: true
        x-originalParamName: request
      responses:
        '201':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.RunbookRule'
          description: Created
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Bad Request
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/openapi.HTTPError'
          description: Internal Server Error
components:
  schemas:
    openapi.RunbookRuleRequest:
      properties:
        connections:
          description: The connection names that this rule applies to
          example:
            - pgdemo
            - bash
          items:
            type: string
          type: array
        description:
          description: The description of the runbook rule
          example: Runbook rules for production databases
          type: string
        name:
          description: The name of the runbook rule
          example: Default Runbook Rules
          type: string
        runbooks:
          description: The runbook files associated with this rule
          items:
            $ref: '#/components/schemas/openapi.RunbookRuleFile'
          type: array
        user_groups:
          description: The user groups names that can access this runbook rule
          example:
            - dba-team
            - devops-team
          items:
            type: string
          type: array
      required:
        - connections
        - name
        - runbooks
        - user_groups
      type: object
    openapi.RunbookRule:
      properties:
        connections:
          description: The connection names that this rule applies to
          example:
            - pgdemo
            - bash
          items:
            type: string
          type: array
        created_at:
          description: The time the resource was created
          example: '2024-07-25T15:56:35.317601Z'
          readOnly: true
          type: string
        description:
          description: The description of the runbook rule
          example: Runbook rules for production databases
          type: string
        id:
          description: The unique identifier of the runbook rule
          example: 15B5A2FD-0706-4A47-B1CF-B93CCFC5B3D7
          format: uuid
          readOnly: true
          type: string
        name:
          description: The name of the runbook rule
          example: Default Runbook Rules
          type: string
        org_id:
          description: Organization ID that owns this runbook rule
          example: 37EEBC20-D8DF-416B-8AC2-01B6EB456318
          format: uuid
          readOnly: true
          type: string
        runbooks:
          description: The runbook files associated with this rule
          items:
            $ref: '#/components/schemas/openapi.RunbookRuleFile'
          type: array
        updated_at:
          description: The time the resource was updated
          example: '2024-07-25T15:56:35.317601Z'
          readOnly: true
          type: string
        user_groups:
          description: The user groups names that can access this runbook rule
          example:
            - dba-team
            - devops-team
          items:
            type: string
          type: array
      required:
        - connections
        - name
        - runbooks
        - user_groups
      type: object
    openapi.HTTPError:
      properties:
        message:
          example: the error description
          type: string
      type: object
    openapi.RunbookRuleFile:
      properties:
        name:
          description: The relative git path of the runbook file
          example: ops/update-user.runbook.sh
          type: string
        repository:
          description: The normalized name of the repository
          example: github.com/myorg/myrepo
          type: string
      type: object

````